Botan: Botan::Base64_Decoder Class Reference

Botan 1.10.12

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | List of all members
Botan::Base64_Decoder Class Reference

`#include <b64_filt.h>`

Inheritance diagram for Botan::Base64_Decoder:

## Public Member Functions
virtual bool | attachable ()
| Base64_Decoder (Decoder_Checking checking=NONE)
void | end_msg ()
std::string | name () const
virtual void | start_msg ()
void | write (const byte input[], size_t length)

## Protected Member Functions
void | send (const byte in[], size_t length)
void | send (byte in)
void | send (const MemoryRegion< byte > &in)
void | send (const MemoryRegion< byte > &in, size_t length)

## Detailed Description

This object represents a Base64 decoder.

Definition at line 57 of file b64_filt.h.

## Constructor & Destructor Documentation

Botan::Base64_Decoder::Base64_Decoder | ( | Decoder_Checking | checking = `NONE` | ) |

Create a base64 decoder.

Parameters

  checking | the type of checking that shall be performed by the decoder

Definition at line 116 of file b64_filt.cpp.

116 :
117 checking(c), in(64), out(48), position(0)
118 {
119 }

## Member Function Documentation

virtual bool Botan::Filter::attachable | ( |  | ) |
| inlinevirtualinherited

Check whether this filter is an attachable filter.

Returns
  true if this filter is attachable, false otherwise

Reimplemented in Botan::SecureQueue, and Botan::DataSink.

Definition at line 50 of file filter.h.

50 { return true; }

void Botan::Base64_Decoder::end_msg | ( |  | ) |
| virtual

Finish up the current message

Reimplemented from Botan::Filter.

Definition at line 163 of file b64_filt.cpp.

References Botan::base64_decode(), Botan::FULL_CHECK, and Botan::Filter::send().

164 {
165 size_t consumed = 0;
166 size_t written = base64_decode(&out[0],
167 reinterpret_cast<const char*>(&in[0]),
168 position,
169 consumed,
170 true,
171 checking != FULL_CHECK);
172
173 send(out, written);
174
175 const bool not_full_bytes = consumed != position;
176
177 position = 0;
178
179 if(not_full_bytes)
180 throw std::invalid_argument("Base64_Decoder: Input not full bytes");
181 }
Botan::base64_decode
size_t base64_decode(byte output[], const char input[], size_t input_length, size_t &input_consumed, bool final_inputs, bool ignore_ws)
Definition: base64.cpp:100
Botan::FULL_CHECK
Definition: filter.h:155
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28

std::string Botan::Base64_Decoder::name | ( |  | ) | const
| inlinevirtual

Returns
  descriptive name for this filter

Implements Botan::Filter.

Definition at line 60 of file b64_filt.h.

References Botan::NONE.

60 { return "Base64_Decoder"; }

void Botan::Filter::send | ( | const byte | in[],
|  | size_t | length
| ) |  |
| protectedinherited

Parameters

  in | some input for the filter
  length | the length of in

Definition at line 28 of file filter.cpp.

References Botan::MemoryRegion< T >::clear(), Botan::Filter::end_msg(), Botan::MemoryRegion< T >::size(), Botan::Filter::start_msg(), and Botan::Filter::write().

Referenced by Botan::Base64_Encoder::Base64_Encoder(), Botan::EAX_Decryption::EAX_Decryption(), Botan::PK_Encryptor_Filter::end_msg(), Botan::Bzip_Compression::end_msg(), Botan::Zlib_Compression::end_msg(), Botan::PBE_PKCS5v15::end_msg(), Botan::Hex_Encoder::end_msg(), Botan::Base64_Encoder::end_msg(), Botan::PBE_PKCS5v20::end_msg(), Botan::PK_Decryptor_Filter::end_msg(), Botan::Bzip_Decompression::end_msg(), Botan::Zlib_Decompression::end_msg(), Botan::PK_Signer_Filter::end_msg(), Botan::Hex_Decoder::end_msg(), end_msg(), Botan::PK_Verifier_Filter::end_msg(), Botan::Hash_Filter::end_msg(), Botan::MAC_Filter::end_msg(), Botan::Bzip_Compression::flush(), Botan::Zlib_Compression::flush(), Botan::Hex_Encoder::Hex_Encoder(), Botan::ECB_Encryption::name(), Botan::EAX_Base::name(), Botan::ECB_Decryption::name(), Botan::CTS_Encryption::set_iv(), Botan::CFB_Encryption::set_iv(), Botan::CBC_Encryption::set_iv(), Botan::CFB_Decryption::set_iv(), Botan::CTS_Decryption::set_iv(), Botan::CBC_Decryption::set_iv(), Botan::XTS_Encryption::set_key(), Botan::XTS_Decryption::set_key(), Botan::Bzip_Compression::write(), Botan::Zlib_Compression::write(), Botan::StreamCipher_Filter::write(), Botan::Bzip_Decompression::write(), Botan::Zlib_Decompression::write(), Botan::Hex_Decoder::write(), and write().

29 {
30 bool nothing_attached = true;
31 for(size_t j = 0; j != total_ports(); ++j)
32 if(next[j])
33 {
34 if(write_queue.size())
35 next[j]->write(&write_queue[0], write_queue.size());
36 next[j]->write(input, length);
37 nothing_attached = false;
38 }
39
40 if(nothing_attached)
41 write_queue += std::make_pair(input, length);
42 else
43 write_queue.clear();
44 }
Botan::Filter::write
virtual void write(const byte input[], size_t length)=0
Botan::MemoryRegion::clear
void clear()
Definition: secmem.h:152
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29

void Botan::Filter::send | ( | byte | in | ) |
| inlineprotectedinherited

Parameters

  in | some input for the filter

Definition at line 63 of file filter.h.

References Botan::Filter::send().

Referenced by Botan::Filter::send().

63 { send(&in, 1); }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28

void Botan::Filter::send | ( | const MemoryRegion< byte > & | in | ) |
| inlineprotectedinherited

Parameters

  in | some input for the filter

Definition at line 68 of file filter.h.

References Botan::Filter::send(), and Botan::MemoryRegion< T >::size().

Referenced by Botan::Filter::send().

68 { send(&in[0], in.size()); }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29

void Botan::Filter::send | ( | const MemoryRegion< byte > & | in,
|  | size_t | length
| ) |  |
| inlineprotectedinherited

Parameters

  in | some input for the filter
  length | the number of bytes of in to send

Definition at line 74 of file filter.h.

75 {
76 send(&in[0], length);
77 }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28

virtual void Botan::Filter::start_msg | ( |  | ) |
| inlinevirtualinherited

Start a new message. Must be closed by end_msg() before another message can be started.

Reimplemented in Botan::Zlib_Decompression, Botan::EAX_Base, Botan::Bzip_Decompression, Botan::PBE_PKCS5v20, Botan::PBE_PKCS5v15, Botan::Bzip_Compression, and Botan::Zlib_Compression.

Definition at line 38 of file filter.h.

Referenced by Botan::Filter::send().

38 {}

void Botan::Base64_Decoder::write | ( | const byte | input[],
|  | size_t | length
| ) |  |
| virtual

Input a part of a message to the decoder.

Parameters

  input | the message to input as a byte array
  length | the length of the byte array input

Implements Botan::Filter.

Definition at line 124 of file b64_filt.cpp.

References Botan::base64_decode(), Botan::copy_mem(), Botan::FULL_CHECK, Botan::MemoryRegion< T >::resize(), Botan::Filter::send(), and Botan::MemoryRegion< T >::size().

125 {
126 while(length)
127 {
128 size_t to_copy = std::min<size_t>(length, in.size() - position);
129 if(to_copy == 0)
130 {
131 in.resize(in.size()*2);
132 out.resize(out.size()*2);
133 }
134 copy_mem(&in[position], input, to_copy);
135 position += to_copy;
136
137 size_t consumed = 0;
138 size_t written = base64_decode(&out[0],
139 reinterpret_cast<const char*>(&in[0]),
140 position,
141 consumed,
142 false,
143 checking != FULL_CHECK);
144
145 send(out, written);
146
147 if(consumed != position)
148 {
149 copy_mem(&in[0], &in[consumed], position - consumed);
150 position = position - consumed;
151 }
152 else
153 position = 0;
154
155 length -= to_copy;
156 input += to_copy;
157 }
158 }
Botan::MemoryRegion::resize
void resize(size_t n)
Definition: secmem.h:211
Botan::base64_decode
size_t base64_decode(byte output[], const char input[], size_t input_length, size_t &input_consumed, bool final_inputs, bool ignore_ws)
Definition: base64.cpp:100
Botan::FULL_CHECK
Definition: filter.h:155
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29
Botan::copy_mem
void copy_mem(T *out, const T *in, size_t n)
Definition: mem_ops.h:22

The documentation for this class was generated from the following files:

- src/filters/codec_filt/b64_filt.h
- src/filters/codec_filt/b64_filt.cpp